Page MenuHomeFreeBSD

Use buf to send speedup
ClosedPublic

Authored by imp on Jan 9 2020, 11:10 PM.

Details

Summary

It turns out there's a problem with using g_io to send the speedup. It leads to
a race when there's a resource shortage when a disk fails.

Instead, send BIO_SPEEDUP via struct buf. This is pretty straight forward,
except we need to transfer the bio_flags from b_ioflags for BIO_SPEEDUP commands
in g_vfs_strategy.

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

imp created this revision.Jan 9 2020, 11:10 PM
mckusick accepted this revision.Jan 13 2020, 4:47 AM

I have never been a fan of short-circuiting the layers, so am fine with keeping them intact.

This revision is now accepted and ready to land.Jan 13 2020, 4:47 AM
chs accepted this revision.Jan 16 2020, 10:44 PM

minor nit: the returned "resid" value is unused. otherwise looks good.

imp added a comment.Jan 17 2020, 12:54 AM
In D23117#508978, @chs wrote:

minor nit: the returned "resid" value is unused. otherwise looks good.

I go back and forth on this. I'd like the interface to return how much of the shortage it could handle, but neither place I use it now does....
I'll take it out for now.

This revision was automatically updated to reflect the committed changes.